/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.21 from the
 * contents of Scan.xs. Do not edit this file, edit Scan.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Scan.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "common.c"
#include "ape.c"
#include "id3.c"

#include "aac.c"
#include "asf.c"
#include "mac.c"
#include "mp3.c"
#include "mp4.c"
#include "mpc.c"
#include "ogg.c"
#include "wav.c"
#include "flac.c"
#include "wavpack.c"

#include "md5.c"

#define FILTER_TYPE_INFO 0x01
#define FILTER_TYPE_TAGS 0x02

#define MD5_BUFFER_SIZE 4096

struct _types {
  char *type;
  char *suffix[15];
};

typedef struct {
  char*	type;
  int (*get_tags)(PerlIO *infile, char *file, HV *info, HV *tags);
  int (*get_fileinfo)(PerlIO *infile, char *file, HV *tags);
  int (*find_frame)(PerlIO *infile, char *file, int offset);
  int (*find_frame_return_info)(PerlIO *infile, char *file, int offset, HV *info);
} taghandler;

struct _types audio_types[] = {
  {"mp4", {"mp4", "m4a", "m4b", "m4p", "m4v", "m4r", "k3g", "skm", "3gp", "3g2", "mov", 0}},
  {"aac", {"aac", 0}},
  {"mp3", {"mp3", "mp2", 0}},
  {"ogg", {"ogg", "oga", 0}},
  {"mpc", {"mpc", "mp+", "mpp", 0}},
  {"ape", {"ape", "apl", 0}},
  {"flc", {"flc", "flac", "fla", 0}},
  {"asf", {"wma", "asf", "wmv", 0}},
  {"wav", {"wav", "aif", "aiff", 0}},
  {"wvp", {"wv", 0}},
  {0, {0, 0}}
};

static taghandler taghandlers[] = {
  { "mp4", get_mp4tags, 0, mp4_find_frame, mp4_find_frame_return_info },
  { "aac", get_aacinfo, 0, 0, 0 },
  { "mp3", get_mp3tags, get_mp3fileinfo, mp3_find_frame, 0 },
  { "ogg", get_ogg_metadata, 0, ogg_find_frame, 0 },
  { "mpc", get_ape_metadata, get_mpcfileinfo, 0, 0 },
  { "ape", get_ape_metadata, get_macfileinfo, 0, 0 },
  { "flc", get_flac_metadata, 0, flac_find_frame, 0 },
  { "asf", get_asf_metadata, 0, asf_find_frame, 0 },
  { "wav", get_wav_metadata, 0, 0, 0 },
  { "wvp", get_ape_metadata, get_wavpack_info, 0 },
  { NULL, 0, 0, 0 }
};

static taghandler *
_get_taghandler(char *suffix)
{
  int typeindex = -1;
  int i, j;
  taghandler *hdl = NULL;
  
  for (i=0; typeindex==-1 && audio_types[i].type; i++) {
    for (j=0; typeindex==-1 && audio_types[i].suffix[j]; j++) {
#ifdef _MSC_VER
      if (!stricmp(audio_types[i].suffix[j], suffix)) {
#else
      if (!strcasecmp(audio_types[i].suffix[j], suffix)) {
#endif
        typeindex = i;
        break;
      }
    }
  }
    
  if (typeindex > -1) {
    for (hdl = taghandlers; hdl->type; ++hdl)
      if (!strcmp(hdl->type, audio_types[typeindex].type))
        break;
  }
  
  return hdl;
}

static void
_generate_md5(PerlIO *infile, const char *file, int size, int start_offset, HV *info)
{
  md5_state_t md5;
  md5_byte_t digest[16];
  char hexdigest[33];
  Buffer buf;
  int audio_offset, audio_size, di;
  
  buffer_init(&buf, MD5_BUFFER_SIZE);
  md5_init(&md5);
  
  audio_offset = SvIV(*(my_hv_fetch(info, "audio_offset")));
  audio_size = SvIV(*(my_hv_fetch(info, "audio_size")));
  
  if (!start_offset) {
    // Read bytes from middle of file to reduce chance of silence generating false matches
    start_offset = audio_offset;
    start_offset += (audio_size / 2) - (size / 2);
    if (start_offset < audio_offset)
      start_offset = audio_offset;
  }
  
  if (size >= audio_size) {
    size = audio_size;
  }
  
  DEBUG_TRACE("Using %d bytes for audio MD5, starting at %d\n", size, start_offset);
  
  if (PerlIO_seek(infile, start_offset, SEEK_SET) < 0) {
    warn("Audio::Scan unable to determine MD5 for %s\n", file);
    goto out;
  }
  
  while (size > 0) {
    if ( !_check_buf(infile, &buf, 1, MIN(size, MD5_BUFFER_SIZE)) ) {
      warn("Audio::Scan unable to determine MD5 for %s\n", file);
      goto out;
    }
    
    md5_append(&md5, buffer_ptr(&buf), buffer_len(&buf));
    
    size -= buffer_len(&buf);
    buffer_consume(&buf, buffer_len(&buf));
    DEBUG_TRACE("%d bytes left\n", size);
  }
  
  md5_finish(&md5, digest);
  
  for (di = 0; di < 16; ++di)
    sprintf(hexdigest + di * 2, "%02x", digest[di]);
  
  my_hv_store(info, "audio_md5", newSVpvn(hexdigest, 32));
  
out:
  buffer_free(&buf);
}

#line 167 "Scan.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 219 "Scan.c"

XS(XS_Audio__Scan__scan); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Scan__scan)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 7)
       croak_xs_usage(cv,  "char *, suffix, infile, path, filter, md5_size, md5_offset");
    {
	HV *	RETVAL;
	char *	suffix = (char *)SvPV_nolen(ST(1));
	PerlIO *	infile = IoIFP(sv_2io(ST(2)));
	SV *	path = ST(3);
	int	filter = (int)SvIV(ST(4));
	int	md5_size = (int)SvIV(ST(5));
	int	md5_offset = (int)SvIV(ST(6));
#line 162 "Scan.xs"
{
  taghandler *hdl;
  RETVAL = newHV();

  // don't leak
  sv_2mortal( (SV*)RETVAL );

  hdl = _get_taghandler(suffix);

  if (hdl) {
    HV *info = newHV();

    // Ignore filter if a file type has only one function (FLAC/Ogg)
    if ( !hdl->get_fileinfo ) {
      filter = FILTER_TYPE_INFO | FILTER_TYPE_TAGS;
    }

    if ( hdl->get_fileinfo && (filter & FILTER_TYPE_INFO) ) {
      hdl->get_fileinfo(infile, SvPVX(path), info);
    }

    if ( hdl->get_tags && (filter & FILTER_TYPE_TAGS) ) {
      HV *tags = newHV();
      hdl->get_tags(infile, SvPVX(path), info, tags);
      hv_store( RETVAL, "tags", 4, newRV_noinc( (SV *)tags ), 0 );
    }

    // Generate audio MD5 value
    if ( md5_size > 0
      && my_hv_exists(info, "audio_offset")
      && my_hv_exists(info, "audio_size")
      && !my_hv_exists(info, "audio_md5")
    ) {
      _generate_md5(infile, SvPVX(path), md5_size, md5_offset, info);
    }

    // Info may be used in tag function, i.e. to find tag version
    hv_store( RETVAL, "info", 4, newRV_noinc( (SV *)info ), 0 );
  }
  else {
    croak("Audio::Scan unsupported file type: %s (%s)", suffix, SvPVX(path));
  }
}
#line 283 "Scan.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Audio__Scan__find_frame); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Scan__find_frame)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "char *, suffix, infile, path, offset");
    {
	int	RETVAL;
	dXSTARG;
	char *	suffix = (char *)SvPV_nolen(ST(1));
	PerlIO *	infile = IoIFP(sv_2io(ST(2)));
	SV *	path = ST(3);
	int	offset = (int)SvIV(ST(4));
#line 211 "Scan.xs"
{
  taghandler *hdl;

  RETVAL = -1;
  hdl = _get_taghandler(suffix);

  if (hdl && hdl->find_frame) {
    RETVAL = hdl->find_frame(infile, SvPVX(path), offset);
  }
}
#line 319 "Scan.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__Scan__find_frame_return_info); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Scan__find_frame_return_info)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       croak_xs_usage(cv,  "char *, suffix, infile, path, offset");
    {
	HV *	RETVAL;
	char *	suffix = (char *)SvPV_nolen(ST(1));
	PerlIO *	infile = IoIFP(sv_2io(ST(2)));
	SV *	path = ST(3);
	int	offset = (int)SvIV(ST(4));
#line 227 "Scan.xs"
{
  taghandler *hdl = _get_taghandler(suffix);
  RETVAL = newHV();
  sv_2mortal((SV*)RETVAL);

  if (hdl && hdl->find_frame_return_info) {
    hdl->find_frame_return_info(infile, SvPVX(path), offset, RETVAL);
  }
}
#line 352 "Scan.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Audio__Scan_has_flac); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Scan_has_flac)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "void");
    {
	int	RETVAL;
	dXSTARG;
#line 242 "Scan.xs"
{
  RETVAL = 1;
}
#line 377 "Scan.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__Scan_is_supported); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Scan_is_supported)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "char *, path");
    {
	int	RETVAL;
	dXSTARG;
	SV *	path = ST(1);
#line 251 "Scan.xs"
{
  char *suffix = strrchr( SvPVX(path), '.' );

  if (suffix != NULL && *suffix == '.' && _get_taghandler(suffix + 1)) {
    RETVAL = 1;
  }
  else {
    RETVAL = 0;
  }
}
#line 409 "Scan.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Audio__Scan_type_for); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Scan_type_for)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "char *, suffix");
    {
	SV *	RETVAL;
	SV *	suffix = ST(1);
#line 267 "Scan.xs"
{
  taghandler *hdl = NULL;
  char *suff = SvPVX(suffix);

  if (suff == NULL || *suff == '\0') {
    RETVAL = newSV(0);
  }
  else {
    hdl = _get_taghandler(suff);
    if (hdl == NULL) {
      RETVAL = newSV(0);
    }
    else {
      RETVAL = newSVpv(hdl->type, 0);
    }
  }
}
#line 447 "Scan.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Audio__Scan_get_types); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Scan_get_types)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "void");
    {
	AV *	RETVAL;
#line 290 "Scan.xs"
{
  int i;

  RETVAL = newAV();
  sv_2mortal((SV*)RETVAL);
  for (i = 0; audio_types[i].type; i++) {
    av_push(RETVAL, newSVpv(audio_types[i].type, 0));
  }
}
#line 477 "Scan.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Audio__Scan_extensions_for); /* prototype to pass -Wmissing-prototypes */
XS(XS_Audio__Scan_extensions_for)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "char *, type");
    {
	AV *	RETVAL;
	SV *	type = ST(1);
#line 305 "Scan.xs"
{
  int i, j;
  char *t = SvPVX(type);

  RETVAL = newAV();
  sv_2mortal((SV*)RETVAL);
  for (i = 0; audio_types[i].type; i++) {
#ifdef _MSC_VER
    if (!stricmp(audio_types[i].type, t)) {
#else
    if (!strcasecmp(audio_types[i].type, t)) {
#endif

      for (j = 0; audio_types[i].suffix[j]; j++) {
        av_push(RETVAL, newSVpv(audio_types[i].suffix[j], 0));
      }
      break;

    }
  }
}
#line 520 "Scan.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Audio__Scan); /* prototype to pass -Wmissing-prototypes */
XS(boot_Audio__Scan)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        (void)newXS("Audio::Scan::_scan", XS_Audio__Scan__scan, file);
        (void)newXS("Audio::Scan::_find_frame", XS_Audio__Scan__find_frame, file);
        (void)newXS("Audio::Scan::_find_frame_return_info", XS_Audio__Scan__find_frame_return_info, file);
        (void)newXS("Audio::Scan::has_flac", XS_Audio__Scan_has_flac, file);
        (void)newXS("Audio::Scan::is_supported", XS_Audio__Scan_is_supported, file);
        (void)newXS("Audio::Scan::type_for", XS_Audio__Scan_type_for, file);
        (void)newXS("Audio::Scan::get_types", XS_Audio__Scan_get_types, file);
        (void)newXS("Audio::Scan::extensions_for", XS_Audio__Scan_extensions_for, file);
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

